/* Event types */
enum {event_mprog,event_temp, event_misc, event_action};

#include "event.h"


#define MAX_MISC_DATA 4

struct event
{
	struct event *next_global;			/* Next in global bucket */
	struct event *next_local;			/* Next on this object */
	
	int when;						/* When is this event due? (sysdata.pulses) */
	
	union	
	{
		OBJ_DATA 		*obj;
		CHAR_DATA 		*ch;
		ROOM_INDEX_DATA *room;
		AREA_DATA 		*area;
		void			*typeless;
	} actor;

	unsigned int actor_type : 4;
	unsigned int type		: 12;
	unsigned int temporary  : 1;  /* Don't save this one */
	unsigned int no_quit    : 1;  /* Don't allow target to quit */
	unsigned int loading  	: 1;  /* Loading, not inserted in global list yet */
	unsigned int rem_death  : 1;  /* Remove when target dies */
	unsigned int added      : 1; /* Event was added */
	unsigned int subtype    : 10;
	
	union /* Event-dependant data */
	{
		struct
		{
			char *args;
			int  target;	/* Key of target */
			int	 duration;	/* Total time of this event */
		} action;
		
		struct /* Call a program (event_mprog) */
		{	
			char *name;
			int vnum;
		} mprog;
		
		struct /* Temporary events */
		{
			int key;				/* Key.. of some sort */
			void *data;				/* Dynamically allocate data.. of some sort */
			EventCallbackFun *fun; 	/* function to call, if any */
			void **remove;			/* Remove the contents of this when event goes off */
		} temp;
		
		struct /* Misc event of some sort */
		{
			char *text;		 		/* some text? */
			int num[MAX_MISC_DATA];	/* Numbers, if special stuff is not needed */
		} misc;
	} data;
};
